/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package com.sun.spot.ota;

import com.sun.cldc.jna.Function;
import com.sun.cldc.jna.NativeLibrary;
import com.sun.squawk.VM;
import java.io.*;
import javax.microedition.io.*;

/**
 *
 * @author ea149956
 */
public class OtaCommandListener implements Runnable {
    public ServerSocketListener server;
    public StreamConnection connection;
    public boolean keepRunning;
    DataInputStream input = null;
    DataOutputStream output = null;

    public OtaCommandListener(ServerSocketListener server, StreamConnection connection) {
        this.server = server;
        this.connection = connection;
        this.keepRunning = true;
    }

    public void run() {
        try {
            input = connection.openDataInputStream();
            output = connection.openDataOutputStream();
            VM.addShutdownHook(new Thread(new Runnable() {
                public void run() { free(); }
            }));
            while (keepRunning && server.keepRunning) {
                System.out.print("Waiting to read OTA command:");
                String command = input.readUTF();
                System.out.print("===OTA COMMAND RECEIVED:");
                System.out.println(command);
                output.writeUTF("!OK!");
                output.flush();
                if (command.equals("!RUN!")) {
                    VxWorks.reboot(VxWorks.BOOT_QUICK_AUTOBOOT);
                    setRestartVM();
                    VM.stopVM(0);
                }
            }
        } catch (EOFException e) {
        } catch (IOException e) {
            e.printStackTrace();
        } finally {
            free();
        }

    }

    public void free() {
        if (input != null) {try {input.close(); input = null;} catch (IOException e) {}}
        if (output != null) {try {output.close(); output = null;} catch (IOException e) {}}
        if (connection != null) {try {connection.close();} catch (IOException e) {}}
    }

    private static Function setRestartVMFn = NativeLibrary.getDefaultInstance().getFunction("OTAServerRestartVM");
    private void setRestartVM () {
        setRestartVMFn.call0();
    }

}
